=== scripts/CMakeLists.txt ===
# CMakeLists for scripts/

# Find subdirs
SUBDIRS(config)
