=== debian/changelog ===
kvirc (4:4.2.0-3) unstable; urgency=medium

  * Team upload.
  * Switch to debhelper compat level 10.
  * Fix FTBFS in C++14 mode (Closes: #811908).
  * Build with libssl1.0-dev (Closes: #828370).
  * Drop explicit Pre-Depends: multiarch-support.
  * Remove obsolete lintian overrides for menu-icon-missing and
    package-needs-versioned-debhelper-build-depends.
  * Remove the menu file.
  * Use secure Vcs-* URLs.
  * Migrate to automatic debug packages.
  * Bump Standards-Version to 3.9.8.

 -- Andrey Rahmatullin <wrar@debian.org>  Fri, 04 Nov 2016 20:03:49 +0500

kvirc (4:4.2.0-2) unstable; urgency=low

  * Upload to unstable 

 -- Mark Purcell <msp@debian.org>  Sat, 18 May 2013 19:36:33 +1000

kvirc (4:4.2.0-1) experimental; urgency=low

  [ Raúl Sánchez Siles ]
  * New upstream release.
  * Updated debhelper build-depends to better cope with multiarch.
  * Fix "must not be "Multi-Arch: same"" kvirc is Multi-Arch: foreign
    (Closes: #658058)
  * Actually provide valid -dbg package. Added 30_upstream_build-g
  * Fix "Hardening flags missing". Applying suggested changes.
    (Closes: #669189) Thanks to Simon Ruderich.

 -- Mark Purcell <msp@debian.org>  Sun, 03 Mar 2013 10:54:35 +1100
