=== src/modules/url/CMakeLists.txt ===
# CMakeLists for src/modules/url

set(kviurl_SRCS
	libkviurl.cpp
)

set(kvi_module_name kviurl)
include(${CMAKE_SOURCE_DIR}/cmake/module.rules.txt)
